<?php
/* 
Plugin Name: Simple Members Only
Plugin URI:  http://www.stevenfernandez.co.uk/wordpress-plugins/
Description: "Simple Members Only" is a simple way to make your whole website only viewable to members who are logged in. You will be able to assign a page where non-members are redirected or choose for all non-members to just be directed to the login page. Make your wordpress website a members only website in only a few clicks!
Version: 1.0.2
Author: Steven Fernandez
Author URI: http://www.stevenfernandez.co.uk

 === RELEASE NOTES ===
    29-04-2014 - v1.0.0 - first version
    09-09-2014 - v1.0.2 - Works with Wordpress 4.0
    */

register_activation_hook(__FILE__,'simple_members_only_setup_options_page');
$simple_members_only_option = get_option('simple_members_only_optionions');
$members_only_reqpage = $_SERVER["REQUEST_URI"];

$siteurl = get_bloginfo('url');
$wpurl = get_bloginfo('wpurl');
$sitetitle = get_bloginfo('title');

$currenturl = (!empty($_SERVER['HTTPS'])) ? "https://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'] : "http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];

$errormsg = array(
	//
	);

function simple_members_only_setup_options_page()
{
	global $simple_members_only_option;
	
	$simple_members_only_version = get_option('simple_members_only_version');
	$members_only_this_version = '1.0.0';
	
	if (empty($simple_members_only_version))
	{
		add_option('simple_members_only_version', $members_only_this_version);
	} 
	elseif ($simple_members_only_version != $members_only_this_version)
	{
		update_option('simple_members_only_version', $members_only_this_version);
	}
	
	$optionarray_def = array(
		'members_only' => FALSE,
		'redirect_to' => 'login',
		'login_redirect_to' => 'dashboard',
		'redirect_url' => '',
		'redirect' => TRUE
	);
		
	if (empty($simple_members_only_option)){ 
		add_option('simple_members_only_optionions', $optionarray_def, 'Simple Members Only Wordpress Plugin Options');
	}	
}

$wpversion_full = get_bloginfo('version');
$wpversion = preg_replace('/([0-9].[0-9])(.*)/', '$1', $wpversion_full);


function simple_members_only_add_options_page()
{
	if (function_exists('add_options_page'))
	{
		add_options_page('Simple Members Only', 'Simple Members Only', 8, basename(__FILE__), 'simple_members_only_optionions_page');
	}
}

function simple_members_only()
{
	
	global $currenturl, $simple_members_only_option, $errormsg, $userdata, $current_user, $wpurl;
	
	$redirection = members_only_createredirect();
	
	if (empty($userdata->ID)) //Check if user is logged in
	{	

		if ($currenturl == $redirection || 
				$currenturl == $redirection.'/' 
				) 		
		{
			// Do Nothing
		}
		else 
		{
			//Redirect Page
			members_only_redirect($redirection);
		}		
	}
	else //User is logged in
	{
		//Do nothing
	}
}



function members_only_init()
{
	
	global $userdata, $currenturl, $errormsg, $simple_members_only_option, $wpdb;
	
	
	$redirection = members_only_createredirect();
	
	
	$parsed_url = parse_url($currenturl);
	
	
}

function members_only_createredirect()
{
	global $simple_members_only_option, $members_only_reqpage, $siteurl, $wpurl;
	
	if ($simple_members_only_option['redirect_to'] == 'login' || $simple_members_only_option['redirect_to'] == 'specifypage' && $simple_members_only_option['redirect_url'] == '')	
	{
		$output = "/wp-login.php";
		
		if ($simple_members_only_option['redirect'] == TRUE) 
		{
			$output .= "?redirect_to=";
			$output .= $members_only_reqpage;
		}
		
		$output = $wpurl.$output;
	}
	elseif ($simple_members_only_option['redirect_to'] == 'specifypage' && $simple_members_only_option['redirect_url'] != '') 
	{
		$output = '/'.$simple_members_only_option['redirect_url'];
		$output = $siteurl.$output;
	}

	return $output;
}

function members_only_redirect($redirection)
{
	if (function_exists('status_header')) status_header( 302 );
	header("HTTP/1.1 302 Temporary Redirect");
	header("Location:".$redirection);
	exit();
}

function members_only_login_redirect() {
	global $redirect_to, $simple_members_only_option;
	
	if (!isset($_GET['redirect_to']) && $simple_members_only_option['login_redirect_to'] == 'frontpage') 
	{
		$redirect_to = get_option('siteurl');
	}
}

function simple_members_only_optionions_page()
{
	global $wpdb, $wpversion;

	if (isset($_POST['submit']) ) {
	
		if ($_POST['one_time_view_ip'] == 1)
		{
			
			$one_time_view_ip = md5($_SERVER['REMOTE_ADDR']);
		}
		else
		{
			$one_time_view_ip = NULL;
		}
		
	$optionarray_update = array (
		'members_only' => $_POST['members_only'],
		'redirect_to' => $_POST['redirect_to'],
		'login_redirect_to' => $_POST['login_redirect_to'],
		'redirect_url' => $_POST['redirect_url'],
		'redirect' => $_POST['redirect']
	);
	
	update_option('simple_members_only_optionions', $optionarray_update);
	}
	
	$optionarray_def = get_option('simple_members_only_optionions');
	
	$redirecttypes = array(
	'WP Login Page' => 'login',
	'Other Page' => 'specifypage'
	);
	
	foreach ($redirecttypes as $option => $value) {
		if ($value == $optionarray_def['redirect_to']) {
				$selected = 'selected="selected"';
		} else {
				$selected = '';
		}
		
		$redirectoptions .= "\n\t<option value='$value' $selected>$option</option>";
	}
	
	$loginredirecttypes = array(
	'Dashboard' => 'dashboard',
	'Front Page' => 'frontpage'
	);
	
	foreach ($loginredirecttypes as $option => $value) {
		if ($value == $optionarray_def['login_redirect_to']) {
				$selected = 'selected="selected"';
		} else {
				$selected = '';
		}
		
		$login_redirectoptions .= "\n\t<option value='$value' $selected>$option</option>";
	}

?>

<style>

.btn-style{
	border : solid 0px #ffffff;
	border-radius : 7px;
	moz-border-radius : 7px;
	font-size : 17px;
	color : #ffffff;
	padding : 5px 10px;
	background-color : #0074a2;

}

.btn-style:hover {
	cursor:pointer;
}

</style>

	<div class="wrap">
	<h2>Simple Members Only Options</h2>
	<form method="post" action="<?php echo $_SERVER['PHP_SELF'] . '?page=' . basename(__FILE__); ?>&updated=true">
	<fieldset class="options" style="border: none">
	<p>
	Plugin Settings below.
	</p>
	<table width="100%" <?php $wpversion >= 2.5 ? _e('class="form-table"') : _e('cellspacing="2" cellpadding="5" class="editform"'); ?> >
		<tr valign="top">
			<th width="200px" scope="row">Simple Members Only (ON/OFF)</th>
			<td width="100px"><input name="members_only" type="checkbox" id="members_only_inp" value="1" <?php checked('1', $optionarray_def['members_only']); ?>"  /></td>
			<td><span style="color: #555; font-size: .85em;">Check to make this website members only / uncheck to turn it off.</span></td>
		</tr>
	</table>
	</p>
	<h3>Website Access Options</h3>
	<table width="100%" <?php $wpversion >= 2.5 ? _e('class="form-table"') : _e('cellspacing="2" cellpadding="5" class="editform"'); ?> >
		<tr valign="top">
			<th scope="row">Redirect NON Members To</th>
			<td><select name="redirect_to" id="redirect_to_inp"><?php echo $redirectoptions ?></select></td>
			<td><span style="color: #555; font-size: .85em;">Choose where NON Members will be redirected to</span></td>
		</tr>
		<!--<tr valign="top">
			<th width="200px" scope="row">Return User</th>
			<td><span style="color: #555; font-size: .85em;">Choose whether once logged in, the user returns to the originally requested page <em>(Only applies if your redirecting to the login page)</em></span></td>
		</tr>-->
		<tr valign="top">
			<th scope="row">Redirection Page<br/>(For Other Page Option)</th> 
			<td colspan="2"><?php bloginfo('url');?>/<input type="text" name="redirect_url" id="redirect_url_inp" value="<?php echo $optionarray_def['redirect_url']; ?>" size="35" /><br />
			<span style="color: #555; font-size: .85em;">If left blank it will re-direct to the login page (For Specific Page Option)</span></span>
			</td>
		</tr>
		<tr valign="top">
			<th width="200px" scope="row">After Login Redirect to</th>
			<td width="100px"><select name="login_redirect_to" id="login_redirect_to_inp"><?php echo $login_redirectoptions ?></select></td>
			<td><span style="color: #555; font-size: .85em;">Choose where the Member is redirected to after login in.</span></td>
		</tr>
	</table>
	
	</fieldset>
	<p />
	<div class="submit">
		<input name="redirect" type="hidden" id="redirect_inp" value="1" <?php checked('1', $optionarray_def['redirect']); ?>"  />
		<input type="submit" name="submit" class="btn-style" value="<?php _e('Update Options') ?>" />
	</div>
	</form>
<?php
}
add_action('admin_menu', 'simple_members_only_add_options_page');
add_action('login_form', 'members_only_login_redirect');

if ($simple_members_only_option['members_only'] == TRUE) 
{
	add_action('template_redirect', 'simple_members_only');
	add_action('init', 'members_only_init');
	
}

?>